gtkmm: Gdk::Texture Class Reference

gtkmm 4.22.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gdk::Texture Class Reference

Pixel data. More...

`#include <gdkmm/texture.h>`

Inheritance diagram for Gdk::Texture:
[legend]

## Public Member Functions
| Texture (Texture &&src) noexcept
Texture & | operator= (Texture &&src) noexcept
| ~Texture () noexcept override
GdkTexture * | gobj ()
| Provides access to the underlying C GObject.
const GdkTexture * | gobj () const
| Provides access to the underlying C GObject.
GdkTexture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_width () const
| Returns the width of texture, in pixels.
int | get_height () const
| Returns the height of the texture, in pixels.
MemoryFormat | get_format () const
| Gets the memory format most closely associated with the data of the texture.
Glib::RefPtr< ColorState > | get_color_state () const
| Returns the color state associated with the texture.
void | download (guchar *data, gsize stride) const
| Downloads the texture into local memory.
bool | save_to_png (const Glib::ustring &filename) const
| Store the given texture to the filename as a PNG file.
Glib::RefPtr< Glib::Bytes > | save_to_png_bytes () const
| Store the given texture in memory as a PNG file.
bool | save_to_tiff (const std::string &filename) const
| Store the given texture to the filename as a TIFF file.
Glib::RefPtr< Glib::Bytes > | save_to_tiff_bytes () const
| Store the given texture in memory as a TIFF file.
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| The width of the texture, in pixels.
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| The height of the texture, in pixels.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ColorState > > | property_color_state () const
| The color state of the texture.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gdk::Paintable
| Paintable (Paintable &&src) noexcept
Paintable & | operator= (Paintable &&src) noexcept
| ~Paintable () noexcept override
GdkPaintable * | gobj ()
| Provides access to the underlying C GObject.
const GdkPaintable * | gobj () const
| Provides access to the underlying C GObject.
void | snapshot (const Glib::RefPtr< Gdk::Snapshot > & snapshot, double width, double height)
| Snapshots the given paintable with the given width and height.
Glib::RefPtr< const Paintable > | get_current_image () const
| Gets an immutable paintable for the current contents displayed by paintable.
Flags | get_flags () const
| Get flags for the paintable.
int | get_intrinsic_width () const
| Gets the preferred width the paintable would like to be displayed at.
int | get_intrinsic_height () const
| Gets the preferred height the paintable would like to be displayed at.
double | get_intrinsic_aspect_ratio () const
| Gets the preferred aspect ratio the paintable would like to be displayed at.
void | compute_concrete_size (double specified_width, double specified_height, double default_width, double default_height, double &concrete_width, double &concrete_height) const
| Compute a concrete size for the `Gdk::Paintable`.
void | invalidate_contents ()
| Called by implementations of `Gdk::Paintable` to invalidate their contents.
void | invalidate_size ()
| Called by implementations of `Gdk::Paintable` to invalidate their size.
Glib::SignalProxy< void()> | signal_invalidate_contents ()
Glib::SignalProxy< void()> | signal_invalidate_size ()
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Texture > | create_for_pixbuf (const Glib::RefPtr< Pixbuf > &pixbuf)
| Creates a new texture object representing the `Gdk::Pixbuf`.
static Glib::RefPtr< Texture > | create_from_resource (const std::string &resource_path)
| Creates a new texture by loading an image from a resource.
static Glib::RefPtr< Texture > | create_from_file (const Glib::RefPtr< Gio::File > & file)
| Creates a new texture by loading an image from a file.
static Glib::RefPtr< Texture > | create_from_filename (const std::string & path)
| Creates a new texture by loading an image from a file.
static Glib::RefPtr< Texture > | create_from_bytes (const Glib::RefPtr< const Glib::Bytes > & bytes)
| Creates a new texture by loading an image from memory,.
Static Public Member Functions inherited from Gdk::Paintable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| Texture ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gdk::Paintable
| Paintable ()
| You should derive from this class to use it.
virtual void | snapshot_vfunc (const Glib::RefPtr< Gdk::Snapshot > &snapshot, double width, double height)
virtual Glib::RefPtr< Paintable > | get_current_image_vfunc () const
virtual Flags | get_flags_vfunc () const
virtual int | get_intrinsic_width_vfunc () const
virtual int | get_intrinsic_height_vfunc () const
virtual double | get_intrinsic_aspect_ratio_vfunc () const

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gdk::Texture > | wrap (GdkTexture *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gdk::Paintable
Glib::RefPtr< Gdk::Paintable > | wrap (GdkPaintable *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gdk::Paintable
enum class | Flags { Flags::STATIC_SIZE = 1 << 0 , Flags::STATIC_CONTENTS = 1 << 1 }
| Flags about a paintable object. More...

## Detailed Description

Pixel data.

Gdk::Texture is the basic element used to refer to pixel data. It is primarily meant for pixel data that will not change over multiple frames, and will be used for a long time.

There are various ways to create Gdk::Texture objects from a Gdk::Pixbuf, or a Cairo surface, or other pixel data.

The ownership of the pixel data is transferred to the Gdk::Texture instance; you can only make a copy of it, via download().

Gdk::Texture is an immutable object: That means you cannot change anything about it.

Since gtkmm 3.94:

## Constructor & Destructor Documentation

## ◆ Texture() [1/2]

Gdk::Texture::Texture | ( | Texture && | src | ) |
| noexcept

## ◆ ~Texture()

Gdk::Texture::~Texture | ( |  | ) |
| overridenoexcept

## ◆ Texture() [2/2]

Gdk::Texture::Texture | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create_for_pixbuf()

static Glib::RefPtr< Texture > Gdk::Texture::create_for_pixbuf | ( | const Glib::RefPtr< Pixbuf > & | pixbuf | ) |
| static

Creates a new texture object representing the `Gdk::Pixbuf`.

This function is threadsafe, so that you can e.g. use GTask and Gio::Task::run_in_thread() to avoid blocking the main thread while loading a big image.

Deprecated: 4.20: Use e.g. libglycin, which can load many image formats into a `Gdk::Texture`

Deprecated:
  4.20: Use e.g. libglycin (a C library), which can load many image formats into GdkTexture.

Parameters

  pixbuf | A `Gdk::Pixbuf`.

Returns
  A new `Gdk::Texture`.

## ◆ create_from_bytes()

static Glib::RefPtr< Texture > Gdk::Texture::create_from_bytes | ( | const Glib::RefPtr< const Glib::Bytes > & | bytes | ) |
| static

Creates a new texture by loading an image from memory,.

The file format is detected automatically. The supported formats are PNG, JPEG and TIFF, though more formats might be available.

If `nullptr` is returned, then error will be set.

This function is threadsafe, so that you can e.g. use GTask and Gio::Task::run_in_thread() to avoid blocking the main thread while loading a big image.

::: warning Note that this function should not be used with untrusted data. Use a proper image loading framework such as libglycin, which can load many image formats into a `Gdk::Texture`.

Since gtkmm 4.6:

Parameters

  bytes | A `Glib::Bytes` containing the data to load.

Returns
  A newly-created `Gdk::Texture`.

Exceptions

  Glib::Error |

## ◆ create_from_file()

static Glib::RefPtr< Texture > Gdk::Texture::create_from_file | ( | const Glib::RefPtr< Gio::File > & | file | ) |
| static

Creates a new texture by loading an image from a file.

The file format is detected automatically. The supported formats are PNG, JPEG and TIFF, though more formats might be available.

If `nullptr` is returned, then error will be set.

This function is threadsafe, so that you can e.g. use GTask and Gio::Task::run_in_thread() to avoid blocking the main thread while loading a big image.

::: warning Note that this function should not be used with untrusted data. Use a proper image loading framework such as libglycin, which can load many image formats into a `Gdk::Texture`.

Parameters

  file | `File` to load.

Returns
  A newly-created `Gdk::Texture`.

Exceptions

  Glib::Error |

## ◆ create_from_filename()

static Glib::RefPtr< Texture > Gdk::Texture::create_from_filename | ( | const std::string & | path | ) |
| static

Creates a new texture by loading an image from a file.

The file format is detected automatically. The supported formats are PNG, JPEG and TIFF, though more formats might be available.

If `nullptr` is returned, then error will be set.

This function is threadsafe, so that you can e.g. use GTask and Gio::Task::run_in_thread() to avoid blocking the main thread while loading a big image.

::: warning Note that this function should not be used with untrusted data. Use a proper image loading framework such as libglycin, which can load many image formats into a `Gdk::Texture`.

Since gtkmm 4.6:

Parameters

  path | The filename to load.

Returns
  A newly-created `Gdk::Texture`.

Exceptions

  Glib::Error |

## ◆ create_from_resource()

static Glib::RefPtr< Texture > Gdk::Texture::create_from_resource | ( | const std::string & | resource_path | ) |
| static

Creates a new texture by loading an image from a resource.

The file format is detected automatically. The supported formats are PNG, JPEG and TIFF, though more formats might be available.

It is a fatal error if resource_path does not specify a valid image resource and the program will abort if that happens. If you are unsure about the validity of a resource, use new_from_file() to load it.

This function is threadsafe, so that you can e.g. use GTask and Gio::Task::run_in_thread() to avoid blocking the main thread while loading a big image.

Parameters

  resource_path | The path of the resource file.

Returns
  A newly-created `Gdk::Texture`.

## ◆ download()

void Gdk::Texture::download | ( | guchar * | data,
|  | gsize | stride
| ) |  | const

Downloads the texture into local memory.

This may be an expensive operation, as the actual texture data may reside on a GPU or on a remote display server.

The data format of the downloaded data is equivalent to Cairo::Surface::Format::ARGB32, so every downloaded pixel requires 4 bytes of memory.

Downloading a texture into a Cairo image surface:

[C example ellipted]

For more flexible download capabilities, see Gdk::TextureDownloader.

Parameters

  data | Pointer to enough memory to be filled with the downloaded data of texture.
  stride | Rowstride in bytes.

## ◆ get_color_state()

Glib::RefPtr< ColorState > Gdk::Texture::get_color_state | ( |  | ) | const

Returns the color state associated with the texture.

Since gtkmm 4.16:

Returns
  The color state of the `Gdk::Texture`.

## ◆ get_format()

MemoryFormat Gdk::Texture::get_format | ( |  | ) | const

Gets the memory format most closely associated with the data of the texture.

Note that it may not be an exact match for texture data stored on the GPU or with compression.

The format can give an indication about the bit depth and opacity of the texture and is useful to determine the best format for downloading the texture.

Since gtkmm 4.10:

Returns
  The preferred format for the texture's data.

## ◆ get_height()

int Gdk::Texture::get_height | ( |  | ) | const

Returns the height of the texture, in pixels.

Returns
  The height of the `Gdk::Texture`.

## ◆ get_type()

static GType Gdk::Texture::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_width()

int Gdk::Texture::get_width | ( |  | ) | const

Returns the width of texture, in pixels.

Returns
  The width of the `Gdk::Texture`.

## ◆ gobj() [1/2]

GdkTexture * Gdk::Texture::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkTexture * Gdk::Texture::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkTexture * Gdk::Texture::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

Texture & Gdk::Texture::operator= | ( | Texture && | src | ) |
| noexcept

## ◆ property_color_state()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ColorState > > Gdk::Texture::property_color_state | ( |  | ) | const

The color state of the texture.

Since gtkmm 4.16:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_height()

Glib::PropertyProxy_ReadOnly< int > Gdk::Texture::property_height | ( |  | ) | const

The height of the texture, in pixels.

Default value: 1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_width()

Glib::PropertyProxy_ReadOnly< int > Gdk::Texture::property_width | ( |  | ) | const

The width of the texture, in pixels.

Default value: 1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ save_to_png()

bool Gdk::Texture::save_to_png | ( | const Glib::ustring & | filename | ) | const

Store the given texture to the filename as a PNG file.

This is a utility function intended for debugging and testing. If you want more control over formats, proper error handling or want to store to a Gio::File or other location, you might want to use save_to_png_bytes() or look into the libglycin library.

Parameters

  filename | The filename to store to.

Returns
  `true` if saving succeeded, `false` on failure.

## ◆ save_to_png_bytes()

Glib::RefPtr< Glib::Bytes > Gdk::Texture::save_to_png_bytes | ( |  | ) | const

Store the given texture in memory as a PNG file.

Use new_from_bytes() to read it back.

If you want to serialize a texture, this is a convenient and portable way to do that.

If you need more control over the generated image, such as attaching metadata, you should look into an image handling library such as the libglycin library.

If you are dealing with high dynamic range float data, you might also want to consider save_to_tiff_bytes() instead.

Since gtkmm 4.6:

Returns
  A newly allocated `Glib::Bytes` containing PNG data.

## ◆ save_to_tiff()

bool Gdk::Texture::save_to_tiff | ( | const std::string & | filename | ) | const

Store the given texture to the filename as a TIFF file.

GTK will attempt to store data without loss.

Since gtkmm 4.6:

Parameters

  filename | The filename to store to.

Returns
  `true` if saving succeeded, `false` on failure.

## ◆ save_to_tiff_bytes()

Glib::RefPtr< Glib::Bytes > Gdk::Texture::save_to_tiff_bytes | ( |  | ) | const

Store the given texture in memory as a TIFF file.

Use new_from_bytes() to read it back.

This function is intended to store a representation of the texture's data that is as accurate as possible. This is particularly relevant when working with high dynamic range images and floating-point texture data.

If that is not your concern and you are interested in a smaller size and a more portable format, you might want to use save_to_png_bytes().

Since gtkmm 4.6:

Returns
  A newly allocated `Glib::Bytes` containing TIFF data.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::Texture > wrap | ( | GdkTexture * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.